function tab_toplist0 = list_corr(ft,xt,xname,xcatcode, k,j, cat_name)
% List top j correlation up to k factors
% input: ft, xt, xname ...

% % input
% ft = F1_til; % make it T by N
% xt = X1'; % make it T by N
% j  = 15; %top 10 correlation
% k  = k;

% program starts here
xindx = (1:1:size(xname,1))';

% % catcode names
% cat_name = { ...
% 'NIPA' ;...    %'NIPA'                   
% 'IP  ' ;...    %'IP'                     
% 'Emp ' ;...    %'Emp/Unemp'              
% 'HSS ' ;...    %'Hous.Starts'            
% 'Ord ' ;...    %'Orders/Inv/Sales'       
% 'Pri ' ;...    %'Prices'                 
% 'Prod' ;...    %'EmpEarning/Productivity'
% 'IntR' ;...    %'Int. Rates'             
% 'Mon ' ;...    %'Money&Credit'           
% 'StPr' ;...    %'StockPrices&Wealth'     
% 'HoPr' ;...    %'Housing Prices'         
% 'ExR ' ;...    %'Exch.Rates'             
% '' ;...    %''                       
% '' ;...    %'Other'                        
% };

for ii = 1:1:k
    % ii = 1;
    
    fxcorr     = corr(ft(:,ii), xt);
    temp_list  = [xname, num2cell(fxcorr'), ...
                  cat_name(floor(xcatcode)), num2cell(xindx)];
    [~, sindx] = sort(abs(fxcorr)', 'descend');
    top_list   = temp_list(sindx(1:j,:),:); %top j list
    
    
    disp('-----------------------------');
    disp(['Factor ', num2str(ii)]);
    disp(top_list);
    
    % stack table
    tab_null = {'', '', '', ''};
    tab_head = {['Factor', num2str(ii)], 'abs(corr)', 'cat', 'indx'};
    top_list = [tab_null; tab_head; top_list];
    
    if ii == 1
        tab_toplist0 = top_list;
    else
        tab_toplist0 = [tab_toplist0; top_list];
    end
    
end





