function plot_corr(ft,xt,xname,xcatcode,ii)
% Plot correlation of ii th factor with all data
% ii : factor number

% ii = 1; % first factor
% ft = F1_til;
% xt = X1';

fxcorr = corr(ft(:,ii), xt);

xindx = (1:1:size(xname,1))';
cindx = zeros(size(xname,1),1);

% catcode names
cat_name = { ...
'NIPA' ;...    %'NIPA'                   
'IP  ' ;...    %'IP'                     
'Emp ' ;...    %'Emp/Unemp'              
'HSS ' ;...    %'Hous.Starts'            
'Ord ' ;...    %'Orders/Inv/Sales'       
'Pri ' ;...    %'Prices'                 
'Prod' ;...    %'EmpEarning/Productivity'
'IntR' ;...    %'Int. Rates'             
'Mon ' ;...    %'Money&Credit'           
'StPr' ;...    %'StockPrices&Wealth'     
'HoPr' ;...    %'Housing Prices'         
'ExR ' ;...    %'Exch.Rates'             
'' ;...    %''                       
'' ;...    %'Other'                        
};

% generate xtick based on xcatcode
fcatcode = floor(xcatcode);
ucatcode = unique(fcatcode);
nunqcode = length(unique(fcatcode));

for jj = 1:1:nunqcode
    temp_indx = xindx(fcatcode == ucatcode(jj));
    
    cindx(temp_indx(end),1) = ucatcode(jj);
end
xtick      = xindx(cindx~=0);
xticklabel = cat_name(cindx(cindx~=0));

% plot
% plot(abs(fxcorr)')
% bar(abs(fxcorr)', 'basevalue', 0, 'facecolor', rgb('lightgrey'));
bar(abs(fxcorr.^2)', 'basevalue', 0, 'facecolor', rgb('lightgrey'));
ylim([0,1])
hold on
line([repmat(xtick+0.5, 1,2)], get(gca, 'ylim'), 'color', 'r', 'linewidth', 3);
hold off

set(gca, 'xtick', xtick, 'xticklabel', xticklabel, 'fontsize', 15, 'linewidth', 2);
title(['Corr^2 between Data and Factor ', num2str(ii)], 'fontsize', 20);






