function [Sc_est, Sc_se1, Sc_fic, Sc_sic, r_fic, r2_sic]...
    = fit_mse(X,X2,X2_hat,F2_til,com,T,T11,T1_hat,k,r1_hat,r2_hat,psi_est,D)



%----------------------------------------------------------------------
%fit statistics reported
T22=T-T11;
com2 = com(:,end-T22+1:end);
X22 = X(:,end-T22+1:end);

%mse of the shrinkage estimate of loadings and subsample of factors
com2_se2 = psi_est*F2_til(end-T22+1:end,1:r2_hat)'; %only use second sample

%common component after structural change selection
if r1_hat == r2_hat && D==0; %no structural change    
    [F_hat,lambda_hat] = pc_full(X,T,r1_hat);
    com_est = lambda_hat*F_hat'; %NxT
    com2_est = com_est(:,end-T22+1:end);
    
    % use shrinkage estimate of loadings
    com2_se1 = com2_est;
    
else
    [F2_hat,lambda2_hat] = pc_full(X2_hat,T-T1_hat,r2_hat);    
    com2_est = lambda2_hat*F2_hat'; %NxT2
    com2_est = com2_est(:,end-T22+1:end);
    
    com2_se1 = com2_se2;
    
end
dif_est = com2_est-com2; %NxT2
ndif_est=diag(dif_est*dif_est');
Sc_est = mean(ndif_est); %measure for second subsample based on model selection

dif_se1 = com2_se1-com2; %NxT2
ndif_se1=diag(dif_se1*dif_se1');
Sc_se1 = mean(ndif_se1); %measure for second subsample based on model selection

%full sample with IC
jj=2; %ICP2 in Bai-Ng (2002)
DEMEAN=2; %standarize data
[r_fic,lamda_hat,F_hat]=nbplog(X',k,jj,DEMEAN);

[F_hat,lambda_hat] = pc_full(X,T,r_fic);
com_f = lambda_hat*F_hat'; %NxT
com2_f = com_f(:,end-T22+1:end);
dif_f = com2_f-com2; %NxT2
ndif_f=diag(dif_f*dif_f');
Sc_fic = mean(ndif_f); 


%2nd subsample with IC
[r2_sic,lamda_hat,F_hat]=nbplog(X2',k,jj,DEMEAN);
[N,T20] = size(X2);
[F_hat,lambda_hat] = pc_full(X2,T20,r2_sic);
com2_s = lambda_hat*F_hat'; %NxT
com2_s = com2_s(:,end-T22+1:end);
size(com2_s)
size(com2)
dif_s = com2_s-com2; %NxT2
ndif_s=diag(dif_s*dif_s');
Sc_sic = mean(ndif_s); 