function [mp,rp,rp2,mr,mj,mr_tot] = model_sel_gen(N,T,tao0,taov,r1,r2,k,eta1,eta2,rho1,rho2,a,beta,b,R,cons,R2_1,R2_2)
% edited 08/20/13
% average tuning and startingvalue, new program tuningpara replace the
% codes below.


options=optimset('MaxFunEvals', 200000, 'MaxIter', 500);

ratio = 0.9.^(0:k); %ratio of variance across factors
share1=ratio(1:r1)/sum(ratio(1:r1)); %before break
share2=ratio(1:r2)/sum(ratio(1:r2));

groups=zeros(2*N*k,1); %define the groups for group penalization
for i=1:k   
s=(i-1)*N+1; e=i*N;   
groups(s:e)=i;
s=(k+(i-1))*N+1; e=(k+i)*N; 
groups(s:e)=k+i;  
end

%%%%%% End of Parameter Definition %%%%%%%%
ntao     = size(taov,2);
Sm=zeros(R,3); Sr=zeros(R,2); 
Sj=zeros(R,1);
Sr_tot = zeros(R,3*ntao); 

parfor s=1:R  
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
T1=floor(T*tao0); T2=T-T1;
[X,com] = paneldata(N,T1,T2,r1,r2,rho1,rho2,eta1,eta2,a,beta,b,R2_1,R2_2,share1,share2);

%% ----------------------------------------------------------------
%---------------- set tuning parameters----------------------------
%------------------------------------------------------------------

TuningV=zeros(2*k,ntao);
StartVal=zeros(2*k,ntao);

for j = 1:ntao
    
    tao = taov(j);
    T1  = floor(T*tao); T2=T-T1;       
    
    [Tuning, fpara0] = tuningpara(X,N,T1,T2,k,cons,options);
   
    TuningV(:,j)=Tuning;   
    
    
end

Tuning = mean(TuningV,2);
fpara0 = mean(StartVal,2);
    
%     [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k);
%     R1  = X1-lambda1_til*F1_til'; R2=X2-lambda2_til*F2_til'; %preliminary estimator of residuals
%     
%     %initial tuning parameter
%     e1 = norm(R1,'fro')/(N*T1)^.5+norm(R2,'fro')/(N*T2)^.5;
%     e2 = norm(R2,'fro')/(N*T2)^.5;
%     Fconst1=1/cons;
%     Fconst2=1/cons;
%     Ftuning10 = Fconst1*N^(-.5)*max(T1^(-1.5),N^(-1.5)); %a constant in the tuning parameter for penalization
%     Ftuning20 = Fconst2*N^(-.5)*max(T2^(-1.5),N^(-1.5)); %a constant in the tuning parameter for penalization
%     
%     norml     = sqrt(diag(lambda1_til'*lambda1_til))'; %column norms of Lambda1
%     gamma_til = lambda2_til-lambda1_til;
%     normg     = sqrt(diag(gamma_til'*gamma_til))'; %column norms of Gamma
%     Ftuning1  = e1*Ftuning10*N^2*(norml.^(-4));
%     Ftuning2  = e2*Ftuning20*N^2*(normg.^(-4));
%     
%     %shrinkage estimation based on initial tuning parameter
%     funObj   = @(para)pel_ls(para,X,F1_til,F2_til);  %criterion function function
%     fpara    = [lambda1_til gamma_til];
%     fpara0   = reshape(fpara,2*N*k,1); %starting values
%     Tuning   = [Ftuning1';Ftuning2'];
%     paraest0 = L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
%     fest0    = reshape(paraest0,N,2*k); %preliminary estimator
%     A=diag(fest0'*fest0); B=fest0(:,1:k)+fest0(:,k+1:2*k); C=diag(B'*B);
%     er1=nnz(A(1:k)); er2=nnz(C); estr=max(er1,er2);
%     
%     %update penalty based on preliminary estimator
%     F1_se      = F1_til(:,1:estr);
%     F2_se      = F2_til(:,1:estr);
%     lambda1_se = lambda1_til(:,1:estr);
%     lambda2_se = lambda2_til(:,1:estr);
%     R1_se      = X1-lambda1_se*F1_se'; 
%     R2_se      = X2-lambda2_se*F2_se';
%     e1 = norm(R1_se,'fro')/(N*T1)^.5+norm(R2_se,'fro')/(N*T2)^.5;
%     e2 = norm(R2_se,'fro')/(N*T2)^.5;
%     
%     [F2_tr,lambda2_tr] = rotation_lamb2(F2_se,lambda1_se,lambda2_se,er1); %rotate lambda2_se to update norm of gamma
%     gamma_se        = lambda2_tr-lambda1_se;
%     normg_se        = sqrt(diag(gamma_se'*gamma_se))'; %column norms of Gamma_se
%     normg_n         = normg;
%     normg_n(1:estr) = normg_se; %update norm
%     
%     Ftuning1 = e1*Ftuning10*(N^2)*(norml.^(-4));
%     Ftuning2 = e2*Ftuning20*(N^2)*(normg_n.^(-4));
%     Tuning   = [Ftuning1';Ftuning2'];


 

%% -------------------------------------------------------------------------
% Estimation (loop over the break-region)
% -------------------------------------------------------------------------

rv       = zeros(3,ntao);
paraestv = zeros(2*N*k,ntao);


for j = 1:ntao
    
    tao = taov(j);
    T1  = floor(T*tao); T2=T-T1;
    [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k); %principle component estimator of factors and loadings
    funObj   = @(para)pel_ls(para,X,F1_til,F2_til);  %criterion function function
    
    %update shrinkage estimation using the new penalty
    paraest = L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
    fest    = reshape(paraest,N,2*k); %updated shrinkage estimator
    
    A = diag(fest'*fest); A1 = A(1:k); A2 = A(k+1:2*k); %A2 is the difference.
    r1_hat = find(A1,1,'last');
    if norm(A2)==0
        r2_hat = r1_hat;
    else
        r2_hat = find(A2,1,'last');
        r2_hat = max(r1_hat,r2_hat);
    end
    
    rv(:,j) = [r1_hat+r2_hat;r1_hat;r2_hat]; % rv is 3xntao
    paraestv(:,j) = paraest;
    
    
    
end %end of loop for ntov


%% Break selection criteria
% - Choose the points closest to the conjecture point
rsum   = rv(1,:);
rset = find(rsum==min(rsum));
rmid=ceil(size(rv,2)+1)/2; %this assumes the conjecture point is in the middle of the searching interval
rdist=abs(rset-rmid);
[a1,a2]=min(rdist);
jr=rset(a2);

tao_hat = taov(jr); %break point chosen for model selection
r1_hat  = rv(2,jr);
r2_hat  = rv(3,jr);
paraest = paraestv(:,jr);
fest    = reshape(paraest,N,2*k); %parameter matrix, 1:k is the 1st subsample, k+1:2k: difference

gamma   = fest(:,k+1:2*k); %difference in loading
D       = norm(gamma(:,1:r1_hat),'fro');

%--------------------------------------------------------------
%% model selection results
if r1==r2 && b==0 && rho1==rho2 && eta1 == eta2
    model = 1;
elseif r2>r1
    model = 3;
else model = 2;
end

m1=0;m2=0; m3=0;
% gamma = fest(:,k+1:2*k);
% D=norm(gamma(:,1:r1_hat),'fro');

if model == 1 %no structural change

if r1_hat==r1 && r2_hat == r2 && D==0
   m1=1;  %correct model  
elseif r1_hat==r2_hat && D==0
   m2=1;     
else     
   m3=1;    
end

end

if model == 2 %change in loadings, no new factor

if r1_hat ==r1 && r2_hat == r2 && D>0
   m1=1;  %correct model  
elseif r1_hat==r2_hat && D>0
   m2=1;     
else     
   m3=1;    
end
end

if model == 3 %new factors arise

if r1_hat == r1 && r2_hat == r2
   m1=1;  %correct model  
elseif r2_hat>r1_hat
   m2=1;     
else     
   m3=1;    
end

end

Sm(s,:)=[m1,m2,m3];
Sr(s,:) = [r1_hat, r2_hat]; %number of factors before and after break
Sj(s,:)= tao_hat;

Sr_tot(s,:)=reshape(rv,1,3*ntao); %size of rv is ntao*3


end

mr_tot = mean(Sr_tot);
mr_tot = reshape(mr_tot,3,ntao); %average number of factors for different break dates


%model statistics reproted
mp = mean(Sm); %1x3 row vector
mr = mean(Sr);
mj = mean(Sj); 


rp_s = mean(Sr(:,1)==(r1-1));
rp_e = mean(Sr(:,1)==r1);
rp_l = mean(Sr(:,1)==(r1+1));
rp = [rp_e,rp_s,rp_l]; %1x3 row vector

rp2_s = mean(Sr(:,2)==(r2-1));
rp2_e = mean(Sr(:,2)==r2);
rp2_l = mean(Sr(:,2)==(r2+1));
rp2 = [rp2_e,rp2_s,rp2_l]; %1x3 row vector


% ntao = size(taov,2);
% rv = zeros(3,ntao);
% paraestv = zeros(2*N*k,ntao);
% 
% for j = 1:ntao
%     
% tao = taov(j);    
% T1=floor(T*tao); T2=T-T1;
% [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k); %principle component estimator of factors and loadings
% X1=X(:,1:T1); X2=X(:,T1+1:T);
% R1=X1-lambda1_til*F1_til'; R2=X2-lambda2_til*F2_til'; %preliminary estimator of residuals
% 
% %initial tuning parameter
% e1=norm(R1,'fro')/(N*T1)^.5+norm(R2,'fro')/(N*T2)^.5;
% e2=norm(R2,'fro')/(N*T2)^.5;
% 
% 
% Ftuning10=1/cons*N^(-.5)*max(T1^(-1.5),N^(-1.5)); %a constant in the tuning parameter for penalization
% Ftuning20=1/cons*N^(-.5)*max(T2^(-1.5),N^(-1.5)); %a constant in the tuning parameter for penalization
% norml = sqrt(diag(lambda1_til'*lambda1_til))'; %column norms of Lambda1
% gamma_til=lambda2_til-lambda1_til; 
% normg = sqrt(diag(gamma_til'*gamma_til))'; %column norms of Gamma
% Ftuning1=e1*Ftuning10*N^2*(norml.^(-4));
% Ftuning2=e2*Ftuning20*N^2*(normg.^(-4));
% 
% %shrinkage estimation based on initial tuning parameter
% funObj=@(para)pel_ls(para,X,F1_til,F2_til);  %criterion function function
% fpara=[lambda1_til gamma_til];
% fpara0=reshape(fpara,2*N*k,1); %starting values
% Tuning=[Ftuning1';Ftuning2'];
% paraest0=L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
% fest0=reshape(paraest0,N,2*k); %preliminary estimator
% A=diag(fest0'*fest0); B=fest0(:,1:k)+fest0(:,k+1:2*k); C=diag(B'*B);
% er1=nnz(A(1:k)); er2=nnz(C); estr=max(er1,er2);
%  
% %update penalty based on preliminary estimator
% F1_se = F1_til(:,1:estr);
% F2_se = F2_til(:,1:estr);
% lambda1_se = lambda1_til(:,1:estr);
% lambda2_se = lambda2_til(:,1:estr);
% R1_se=X1-lambda1_se*F1_se'; R2_se=X2-lambda2_se*F2_se';
% e1=norm(R1_se,'fro')/(N*T1)^.5+norm(R2_se,'fro')/(N*T2)^.5;
% e2=norm(R2_se,'fro')/(N*T2)^.5;
% 
% 
% [F2_tr,lambda2_tr] = rotation_lamb2(F2_se,lambda1_se,lambda2_se,er1); %rotate lambda2_se to update norm of gamma
% gamma_se=lambda2_tr-lambda1_se; 
% normg_se = sqrt(diag(gamma_se'*gamma_se))'; %column norms of Gamma_se
% normg_n = normg;
% normg_n(1:estr)=normg_se; %update norm
% 
% Ftuning1=e1*Ftuning10*(N^2)*(norml.^(-4));
% Ftuning2=e2*Ftuning20*(N^2)*(normg_n.^(-4));
% Tuning=[Ftuning1';Ftuning2'];
% 
% %update shrinkage estimation using the new penalty
% paraest=L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
% fest=reshape(paraest,N,2*k); %updated shrinkage estimator
% 
% 
% A=diag(fest'*fest); A1=A(1:k); A2=A(k+1:2*k);
% r1_hat=find(A1,1,'last'); 
% if norm(A2)==0
%     r2_hat=r1_hat;
% else
% r2_hat=find(A2,1,'last');
% r2_hat=max(r1_hat,r2_hat);
% end
% 
% rv(:,j)=[r1_hat+r2_hat;r1_hat;r2_hat];
% paraestv(:,j)=paraest;
% end
% 
% %% Break selection criteria
% % - Choose the points closest to the conjecture point
% rsum   = rv(1,:);
% rset = find(rsum==min(rsum));
% rmid=ceil(size(rv,2)+1)/2; %this assumes the conjecture point is in the middle of the searching interval
% rdist=abs(rset-rmid);
% [a1,a2]=min(rdist);
% jr=rset(a2);
% 
% tao_hat = taov(jr); %break point chosen for model selection
% r1_hat  = rv(2,jr);
% r2_hat  = rv(3,jr);
% paraest = paraestv(:,jr);
% fest    = reshape(paraest,N,2*k); %parameter matrix, 1:k is the 1st subsample, k+1:2k: difference
% 
% gamma   = fest(:,k+1:2*k); %difference in loading
% D       = norm(gamma(:,1:r1_hat),'fro');


% --median method---%
% rsum=rv(1,:);
% rmin = min(rsum,[],2);
% rset = (rsum==rmin);
% rcount = zeros(1,ntao);
% for i=1:ntao
%     rcount(i)=sum(rset(1:i));
% end
% 
% ind = ceil(sum(rset)/2);
% 
% [ir,jr]=find(rcount==ind,1);
% tao_hat = taov(jr);
% Sj(s,:)=taov(jr);
% 
% r1_hat = rv(2,jr);
% r2_hat = rv(3,jr);
% paraest = paraestv(:,jr);
% fest=reshape(paraest,N,2*k);


%----------------------------------------------------------------------
% %mse statistics reported
% T10=floor(T*tao0); T20=T-T10;
% T1_hat=floor(T*tao_hat); T2_hat=T-T1_hat;
% 
% com2 = com(:,T1_hat+1:end);
% X1=X(:,1:T1_hat); X2=X(:,T1_hat+1:T);
% %common component after structural change selection
% if r1_hat == r2_hat && D==0; %no structural change    
%     [F_hat,lambda_hat] = pc_full(X,T,r1_hat);
%     com_est = lambda_hat*F_hat'; %NxT
%     com2_est = com_est(:,T1_hat+1:end);
% else
%     [F2_hat,lambda2_hat] = pc_full(X2,T2_hat,r2_hat);    
%     com2_est = lambda2_hat*F2_hat'; %NxT2
% end
% dif_est = com2_est-com2; %NxT2
% if T20<T2_hat
% dif_est = dif_est(:,end-T20+1:end);
% end
% ndif_est=diag(dif_est*dif_est');
% Sc_est = mean(ndif_est); %measure for second subsample based on model selection
% 
% 
% com2 = com(:,T10+1:end);
% X1=X(:,1:T10); X2=X(:,T10+1:T);
% %full sample with IC
% jj=2; %ICP2 in Bai-Ng (2002)
% DEMEAN=2; %standarize data
% [r_fic,lamda_hat,F_hat]=nbplog(X',k,jj,DEMEAN);
% 
% [F_hat,lambda_hat] = pc_full(X,T,r_fic);
% com_f = lambda_hat*F_hat'; %NxT
% com2_f = com_f(:,T10+1:end);
% dif_f = com2_f-com2; %NxT2
% if T20>T2_hat
% dif_f=dif_f(:,end-T2_hat+1:end);
% end
% ndif_f=diag(dif_f*dif_f');
% Sc_fic = mean(ndif_f); 
% 
% 
% %2nd subsample with IC
% 
% [r2_sic,lamda_hat,F_hat]=nbplog(X2',k,jj,DEMEAN);
% [F2_hat,lambda2_hat] = pc_full(X2,T20,r2_sic);
% com2_s = lambda2_hat*F2_hat'; %NxT2
% dif_s = com2_s-com2; %NxT2
% if T20>T2_hat
% dif_s=dif_s(:,end-T2_hat+1:end);
% end
% ndif_s=diag(dif_s*dif_s');
% Sc_sic = mean(ndif_s); 

%Sc(s,:) = [Sc_est, Sc_fic, Sc_sic];





                                                                                                                                                                                                         