function [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k)
%% This function computes the principle component estimate of the factors
%% for two subsamples.

X1=X(:,1:T1);
X2 = X(:,T1+1:T1+T2);


[f0,eig,f00] = svd(X1'*X1);
F1_til = f0(:,1:k)*sqrt(T1);
lambda1_til=X1*F1_til/T1;


[f0,eig,f00] = svd(X2'*X2);
F2_til = f0(:,1:k)*sqrt(T2);
lambda2_til=X2*F2_til/T2;



%% when no structural change, make sure f1_til and f2_til are approx the
%% same, not the opposite of each other
corv = corr(lambda1_til,lambda2_til);
cor = diag(corv);

sgn = ones(size(lambda2_til));
sgn(:,cor<0)=-1;
lambda2_til = lambda2_til.*sgn;

sgn = ones(size(F2_til));
sgn(:,cor<0)=-1;
F2_til = F2_til.*sgn;







