     %Least Sqaure Criterion Function and Its First Direvatives
%"vpara" is a N*2k matrix with the first N*k submatrix being the loadings
%of the factors before T0 and the last N*k submatrix being the possible
%changes of loadings of the factors after T0; 
%"Data" is a N*T matrix of the observed data; 
%"F1" is a T0*k matrix of the estimated factors before T0; 
%"F2" is a (T-T0)*k matrix of the estimated factors after T0.

function [out g]= pel_ls(vpara,Data,F1,F2)

A=size(Data); N=A(1); 

A=size(F1); T0=A(1); k=A(2); A=size(F2); T1=A(1); T=T0+T1;

para=reshape(vpara,N,2*k);

Lambda=para(:,1:k); Gamma=para(:,k+1:2*k); 

Data1=Data(:,1:T0); Data2=Data(:,T0+1:T);

R1=Data1-Lambda*F1'; R2=Data2-(Lambda+Gamma)*F2';

out=(norm(R1,'fro')^2+norm(R2,'fro')^2)/(N*T);

g=zeros(2*N*k,1);

for i=1:k
    
    s=(i-1)*N+1; e=i*N; 

    g(s:e,:)=(-2*R1*F1(:,i)-2*R2*F2(:,i))/(N*T);

    s=(k+(i-1))*N+1; e=(k+i)*N; 

    g(s:e,:)=-2*R2*F2(:,i)/(N*T);
            
end

end
