     %Least Sqaure Criterion Function and Its First Direvatives
%"vpara" is a N*2k matrix with the first N*k submatrix being the loadings
%of the factors before T0 and the last N*k submatrix being the possible
%changes of loadings of the factors after T0; 
%"Data" is a N*T matrix of the observed data; 
%"F1" is a T0*k matrix of the estimated factors before T0; 
%"F2" is a (T-T0)*k matrix of the estimated factors after T0.

function [out g]= pel_ls_full(vpara,Data,F)

A=size(Data); N=A(1); 

A=size(F); T=A(1); k=A(2); 

para=reshape(vpara,N,k);

Lambda=para(:,1:k); 



R1=Data-Lambda*F'; 

out=norm(R1,'fro')^2/(N*T);

g=zeros(N*k,1);

for i=1:k
    
    s=(i-1)*N+1; e=i*N; 

    g(s:e,:)=(-2*R1*F(:,i))/(N*T);    
            
end

