function [rv,paraestv,Dv] = plsest(X,N,T,k,taov,Tuning,fpara0,groups,options)

ntao     = size(taov,2);
rv = zeros(3,ntao);
paraestv=zeros(2*N*k,ntao);
Dv = zeros(1,ntao);


% first step estimation
for j = 1:ntao
    
    tao = taov(j);
    T1  = floor(T*tao); T2=T-T1;
    [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k); %principle component estimator of factors and loadings
    funObj   = @(para)pel_ls(para,X,F1_til,F2_til);  %criterion function function
        
    paraest = L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
    fest    = reshape(paraest,N,2*k); %updated shrinkage estimator
    
    A = diag(fest'*fest); A1 = A(1:k); A2 = A(k+1:2*k); %A2 is the difference.
    r1_hat = find(A1,1,'last');
    if norm(A2)==0
        r2_hat = r1_hat;
    else
        r2_hat = find(A2,1,'last');        
    end
    r2_hat = max(r1_hat,r2_hat);
    
	% collect results
    rv(:,j) = [r1_hat+r2_hat;r1_hat;r2_hat];
    paraestv(:,j) = paraest;
    
    % some old stuff
    fest    = reshape(paraest,N,2*k); %parameter matrix, 1:k is the 1st subsample, k+1:2k: difference
    gamma   = fest(:,k+1:2*k); %difference in loading
    D       = norm(gamma(:,1:r1_hat),'fro');
    Dv(:,j) = D;
	
end %end of loop for ntov