function r1_hat = rank_est_full(X,k,cons)

[N,T]=size(X);

options=optimset('MaxFunEvals', 200000, 'MaxIter', 500);

groups=zeros(N*k,1); %define the groups for group penalization
for i=1:k   
s=(i-1)*N+1; e=i*N;   
groups(s:e)=i;
end

[F1_til,lambda1_til] = pc_full(X,T,k); %principle component estimator of factors and loadings
X1=X;
R1=X1-lambda1_til*F1_til';  %preliminary estimator of residuals

%initial tuning parameter
e1=norm(R1,'fro')/(N*T)^.5;
Ftuning10=1/cons*N^(-.5)*max(T^(-1.5),N^(-1.5)); %a constant in the tuning parameter for penalization
norml = sqrt(diag(lambda1_til'*lambda1_til))'; %column norms of Lambda1
Ftuning1=e1*Ftuning10*N^2*(norml.^(-4));
%shrinkage estimation based on initial tuning parameter
funObj=@(para)pel_ls_full(para,X,F1_til);  %criterion function function
fpara=lambda1_til;
fpara0=reshape(fpara,N*k,1); %starting values
Tuning= Ftuning1';
paraest0=L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
fest0=reshape(paraest0,N,k); %preliminary estimator
A=diag(fest0'*fest0); 
estr=nnz(A(1:k)); 
 
%update penalty based on preliminary estimator
F1_se = F1_til(:,1:estr);
lambda1_se = lambda1_til(:,1:estr);
R1_se=X1-lambda1_se*F1_se'; 
e1=norm(R1_se,'fro')/(N*T)^.5;



Ftuning1=e1*Ftuning10*(N^2)*(norml.^(-4));
Tuning=Ftuning1';
%update shrinkage estimation using the new penalty
paraest=L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
fest=reshape(paraest,N,k); %updated shrinkage estimator
A=diag(fest'*fest); A1=A(1:k);
if norm(A1)==0
r1_hat=0;
else
r1_hat=find(A1,1,'last'); 
end