function TuningV = tuningpara2(X,N,T,k,taov,cons,er1,er2,normlV,normgV)
% version
% 0: new lambda
% 1: old program but new lam
% 2: old program but new penalty
% 3: old program

%This program computes the adaptive tuning parameter
%8/20/13, taken from the program model_sel.m

%XC. 10/14/2013. Averaging in first step, Gamma Penalty, Defn Ra Rb
%XC. This programs computes the second step tuning parameter

ntao     = size(taov,2);
TuningV  = zeros(2*k,ntao); %collecting tuning vector for searching range


for j = 1:ntao
    
tao = taov(j);
T1  = floor(T*tao); T2=T-T1;    
[F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k); %principle component estimator of factors and loadings
X1=X(:,1:T1); X2=X(:,T1+1:end);


% weights from first step estimation
norml=normlV(:,j);
normg=normgV(:,j);


        F1_se = F1_til(:,1:er1);
        F2_se = F2_til(:,1:er2);
        lambda1_se = lambda1_til(:,1:er1);
        lambda2_se = lambda2_til(:,1:er2);
        R1_se = X1-lambda1_se*F1_se'; R2_se = X2-lambda2_se*F2_se';       
        
        e1 = norm(R1_se,'fro')/(N*T1)^.5+norm(R2_se,'fro')/(N*T2)^.5;
        e2 = norm(R2_se,'fro')/(N*T2)^.5;
        
        
        dp = 2;
       
        Ftuning10 = 1/cons*N^(-.5)*max((T1)^(-(dp+1)/2),N^(-(dp+1)/2)); %a constant in the tuning parameter for penalization
        Ftuning20 = 1/cons*N^(-.5)*max((T2)^(-(dp+1)/2),N^(-(dp+1)/2)); %a constant in the tuning parameter for penalization

        normg_n = normg;
        %new on the rotation method
        if er1==er2
            lambda2_tr = rotation_lamb2(lambda1_se,lambda2_se,er1);
       
        
        
        gamma_se=lambda2_tr-lambda1_se;
        normg_se = sqrt(diag(gamma_se'*gamma_se)); %column norms of Gamma_se
        
        norml2_se = sqrt(diag(lambda2_tr'*lambda2_tr));
        normg_se = min(normg_se,norml2_se);
               
        
        normg_n(1:er2)=normg_se; %update norm
        
        end
        
        %%%%%stop here%%%%%%%%%%%%%%
        
        Ftuning1=e1*Ftuning10*(N^dp)*(norml.^(-2*dp));
        Ftuning2=e2*Ftuning20*(N^dp)*(normg_n.^(-2*dp));
        Tuning=[Ftuning1;Ftuning2];
        
        size (Tuning);
        TuningV(:,j)=Tuning;
end
    
    